"""complete user model

Revision ID: 1f2deebfe933
Revises: d4867f3a4c0a
Create Date: 2021-01-27 13:04:02.637828

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "1f2deebfe933"
down_revision = "d4867f3a4c0a"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    # New Table role #
    op.create_table(
        "role",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("name", sa.String(), nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(op.f("ix_role_id"), "role", ["id"], unique=False)
    op.execute("INSERT INTO role VALUES (1, 'Superuser')")
    op.execute("INSERT INTO role VALUES (2, 'AI Creator')")
    op.execute("INSERT INTO role VALUES (3, 'AI Tester')")

    # Modifying table user #
    op.add_column("user", sa.Column("user_id", sa.String()))
    op.add_column("user", sa.Column("display_name", sa.String(), nullable=True))
    op.add_column("user", sa.Column("role_id", sa.Integer()))
    op.alter_column("user", "email", existing_type=sa.VARCHAR(), nullable=False)
    op.alter_column(
        "user", "hashed_password", existing_type=sa.VARCHAR(), nullable=False
    )
    op.create_index(op.f("ix_user_user_id"), "user", ["user_id"], unique=True)
    op.drop_index("ix_user_full_name", table_name="user")
    op.create_foreign_key("user_role_id_fkey", "user", "role", ["role_id"], ["id"])
    # populate new columns with default if possible ##
    op.execute("UPDATE public.user SET user_id=SPLIT_PART(email, '@', 1)")
    op.execute("UPDATE public.user SET display_name=full_name")
    op.execute("UPDATE public.user SET role_id=3")
    op.execute("UPDATE public.user SET role_id=1 WHERE is_superuser=TRUE")
    # drop unused columns ##
    op.drop_column("user", "is_superuser")
    op.drop_column("user", "full_name")
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "user", sa.Column("full_name", sa.VARCHAR(), autoincrement=False, nullable=True)
    )
    op.add_column(
        "user",
        sa.Column("is_superuser", sa.BOOLEAN(), autoincrement=False, nullable=True),
    )
    op.drop_constraint("user_role_id_fkey", "user", type_="foreignkey")
    op.create_index("ix_user_full_name", "user", ["full_name"], unique=False)
    op.drop_index(op.f("ix_user_user_id"), table_name="user")
    op.alter_column(
        "user", "hashed_password", existing_type=sa.VARCHAR(), nullable=True
    )
    op.alter_column("user", "email", existing_type=sa.VARCHAR(), nullable=True)
    op.drop_column("user", "user_id")
    op.drop_column("user", "role_id")
    op.drop_column("user", "display_name")
    op.drop_index(op.f("ix_role_id"), table_name="role")
    op.drop_table("role")
    # ### end Alembic commands ###
