"""Add tabled for project models

Revision ID: 7a9ee66421fc
Revises: 48927b3c7019
Create Date: 2021-04-17 08:30:40.956227

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "7a9ee66421fc"
down_revision = "48927b3c7019"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "project_models",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("file_name", sa.String(), nullable=False),
        sa.Column("location", sa.String(), nullable=False),
        sa.Column("python_version", sa.String(), nullable=False),
        sa.Column("requirements_file_location", sa.String(), nullable=False),
        sa.Column("owner_id", sa.Integer(), nullable=False),
        sa.Column("project_id", sa.Integer(), nullable=False),
        sa.Column("created_on", sa.DateTime(timezone=True), nullable=True),
        sa.ForeignKeyConstraint(
            ["owner_id"],
            ["user.id"],
        ),
        sa.ForeignKeyConstraint(
            ["project_id"],
            ["projects.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(
        op.f("ix_project_models_file_name"),
        "project_models",
        ["file_name"],
        unique=False,
    )
    op.create_index(
        op.f("ix_project_models_id"), "project_models", ["id"], unique=False
    )
    op.drop_index("ix_projects_id", table_name="projects")
    op.create_index(op.f("ix_projects_id"), "projects", ["id"], unique=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_projects_id"), table_name="projects")
    op.create_index("ix_projects_id", "projects", ["id"], unique=True)
    op.drop_index(op.f("ix_project_models_id"), table_name="project_models")
    op.drop_index(op.f("ix_project_models_file_name"), table_name="project_models")
    op.drop_table("project_models")
    # ### end Alembic commands ###
