"""add column original_data to feedbacks

Revision ID: 815952b51fdc
Revises: 1d23c3b2ac17
Create Date: 2021-09-22 17:46:24.347005

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = '815952b51fdc'
down_revision = '1d23c3b2ac17'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column('feedbacks', 'input_data', new_column_name='user_data')
    op.add_column('feedbacks', sa.Column('original_data', sa.JSON(), nullable=True))
    op.execute("UPDATE feedbacks SET original_data = user_data")
    op.alter_column('feedbacks', 'original_data', nullable=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('feedbacks', 'original_data')
    op.alter_column('feedbacks', 'user_data', new_column_name='input_data')
    # ### end Alembic commands ###
